code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0			; extra word for far jump segment

new21:	cmp	ah,02h			; write character to STDOUT?
	je	single
	cmp	ah,06h			; direct console output?
	je	direct
	cmp	ah,09h			; write string to STDOUT?
	je	string
	cmp	ah,40h			; write to file or device?
	jne	start
	cmp	bx,1			; console handle?
	jne	start

	call	isdev			; forward if not device
	je	start
	push	bp
	mov	bp,sp
	push	cx			; pop into AX for return
	jcxz	none			; zero length?
	push	cx
	push	si
	mov	si,dx			; point source from data
	cld
read1:	lodsb
	call	int29
	loop	read1
	pop	si
	pop	cx
none:	pop	ax			; AX=CX on return
	and	word ptr [bp+6],not 1	; clear carry flag on stack
	pop	bp
	iret

direct:	cmp	dl,0ffh			; input version of function?
	je	start			; fall through to single char

single:	call	isdev			; forward if not device
	je	start
	mov	al,dl
	call	int29
	iret				; AL=DL on return

string:	call	isdev			; forward if not device
	je	start
	push	si
	mov	si,dx
	cld
read2:	lodsb
	cmp	al,'$'			; terminating character?
	je	term
	call	int29
	jmp	read2
term:	pop	si
	iret				; AL='$' on return

isdev:	sti				; let interrupts run
	push	ax
	push	bx
	push	dx
	mov	ax,4400h		; get device information
	mov	bx,1			; console device handle

	pushf				; call DOS interrupt
	push	cs
	call	start

	test	dh,80h			; is device?
	pop	dx
	pop	bx
	pop	ax
	ret

int29:	push	bx			; save BX
	mov	bx,7			; page 0, attribute for white
	int	29h			; call fast output interrupt
	pop	bx			; restore BX
	ret

init:	mov	ax,3521h		; get current INT 21 handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new21		; install new INT 21 handler
	mov	ah,25h
	int	21h

	mov	es,envseg		; free environment seg to save memory
	mov	ah,49h
	int	21h

	mov	dx,0018h		; terminate leaving DX paragraphs resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
